// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_MutexImpl.h,v 1.3 1999/01/29 23:47:21 rasmussn Exp $

#ifndef __HPCXX_MUTEXIMPL_H_
#define __HPCXX_MUTEXIMPL_H_

#include <Smarts.h>
#include <Mutex.h>

class HPCxx_CondImpl;

class HPCxx_MutexImpl {
private:
  Smarts::Mutex mutex_;

public:
  HPCxx_MutexImpl(void);
  HPCxx_MutexImpl(const HPCxx_MutexImpl& mutex);
  ~HPCxx_MutexImpl(void);

  HPCxx_MutexImpl& operator=(const HPCxx_MutexImpl& mutex);

  int lock(void);
  int unlock(void);

  friend HPCxx_CondImpl;
};

#endif
