//-----------------------------------------------------------------------------
// hpcxx_invoke.C -- contains function declarations used in invoking remote
// member functions
//-----------------------------------------------------------------------------

#include <HPCxx_Group.h>
#include <hpcxx_invoke.h>
#include <hpcxx_invoke.cc>
#include <HPCxx_Sync.cc>
#include <HPCxx_SyncQ.cc>
#include <HPCxx_GlobalPtr.cc>
#include <HPCxx_GlobalRefImpl.cc>
#include <hpcxx_register.cc>


int barrierSetUp_id = 24001;

HPCxx_SyncQ<int> barrier_set_up_lock[2];
HPCxx_GlobalPtr<HPCxx_BufferBlock> *barrier_ptr;

// the following is needed to force sun to expand some templates.
HPCxx_Sync<int> foobar_dummy1;
HPCxx_SyncQ<int> foobar_dummy2;

void never_ever_call_me(){
  int i;

  foobar_dummy1.write(i);
  foobar_dummy1.read(i);
  foobar_dummy2.write(i);
  foobar_dummy2.read(i);
}


void hpcxx_typeInit(void) {
  HPCxx_RegisteredType<int> int_registration;
  HPCxx_RegisteredType<u_int> u_int_registration;
  HPCxx_RegisteredType<float> float_registration;
  HPCxx_RegisteredType<double> double_registration;
  HPCxx_RegisteredType<char> char_registration;
  HPCxx_RegisteredType<u_char> u_char_registration;
  HPCxx_RegisteredType<long> long_registration;
  HPCxx_RegisteredType<u_long> u_long_registration;
  HPCxx_RegisteredType<short> short_registration;
  HPCxx_RegisteredType<u_short> u_short_registration;
  /*barrierSetUp_id = hpcxx_register(barrierSetUp, barrierSetUp_id);*/
}


HPCxx_GlobalPtr<HPCxx_BufferBlock>
barrierSetUp(HPCxx_GlobalPtr<HPCxx_BufferBlock> parent, int ParIndx)
{
  int i = barrier_set_up_lock[0];
  HPCxx_GlobalPtr<HPCxx_BufferBlock> *z = barrier_ptr;
  barrier_ptr = new HPCxx_GlobalPtr<HPCxx_BufferBlock>(parent);
  barrier_set_up_lock[1] = ParIndx; 
  return *z;
}


// Force compiler to instantiate (explicitly) those classes that will be
// needed at link stage.


//template class HPCxx_Sync<int>;
//template class HPCxx_SyncQ<int>;
//template class HPCxx_GlobalPtr<HPCxx_BufferBlock>;
//template class HPCxx_GlobalRefImpl<HPCxx_BufferBlock>;

//template int HPCxx_Type<HPCxx_BufferBlock>::registrationID(void);

//template hpcxx_id_t hpcxx_registerClass(int*);
//template hpcxx_id_t hpcxx_registerClass(unsigned int*);
//template hpcxx_id_t hpcxx_registerClass(float*);
//template hpcxx_id_t hpcxx_registerClass(double*);
//template hpcxx_id_t hpcxx_registerClass(char*);
//template hpcxx_id_t hpcxx_registerClass(unsigned char*);
//template hpcxx_id_t hpcxx_registerClass(long*);
//template hpcxx_id_t hpcxx_registerClass(unsigned long*);
//template hpcxx_id_t hpcxx_registerClass(short*);
//template hpcxx_id_t hpcxx_registerClass(unsigned short*);
